// Define function for the Dictionary
function a = define(word)
    word = convstr(word,'l');
    word_length = length(word);
    root = get_function_path('define');
    tmp_ind = strindex(root,'\define.sci');
    root = part(root,1:(tmp_ind-1));
    first_letter = convstr(part(string(word),1:1), "u");
    if or(first_letter == strsplit("A":"Z"))
        A = csvRead(root+'\..\data\'+first_letter+"word.csv",[],[],'string');
        A = part(A, 1:word_length);
        index = grep(A,string(word));
        Amean = csvRead(root+"\..\data\"+first_letter+".csv",[],[],'string');
        matchno = size(index);
        if matchno(2)<5 then
            a = Amean(index(1:matchno(2)));
        else
            a = Amean(index(1:5));
        end
    else
        a = 'Sorry! Word not found. Please check the spelling.';
    end
endfunction

// Private function to count the number of known words and definitions
// Use by admin
function [nbWords, nbDefs] = countWordsDefs()
	nbWords = 0;
	nbDefs = 0;
	[trash, p] = libraryinfo("engdictlib"); // get the path
	for c = strsplit("A":"Z")'
		tmp = mgetl(p+"/../data/"+c+"word.csv");
		nbDefs = nbDefs + size(tmp,1);
		nbWords = nbWords + size(unique(tmp),1);
	end
endfunction
